gtkmm: Gtk::CellRenderer Class Reference

gtkmm 4.7.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::CellRenderer Class Reference
TreeView Classes

CellRenderers are used by Gtk::TreeView columns to render the Gtk::TreeModel column data appropriately. More...

`#include <gtkmm/cellrenderer.h>`

Inheritance diagram for Gtk::CellRenderer:
[legend]

## Public Member Functions
| CellRenderer (CellRenderer && src) noexcept
CellRenderer & | operator= (CellRenderer && src) noexcept
| CellRenderer (const CellRenderer &)=delete
CellRenderer & | operator= (const CellRenderer &)=delete
| ~CellRenderer () noexcept override
GtkCellRenderer * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkCellRenderer * | gobj () const
| Provides access to the underlying C GObject. More...
SizeRequestMode | get_request_mode () const
| Gets whether the cell renderer prefers a height-for-width layout or a width-for-height layout. More...
void | get_preferred_width (Widget & widget, int & minimum_width, int & natural_width) const
| Retrieves a renderer’s natural size when rendered to widget. More...
void | get_preferred_height_for_width (Widget & widget, int width, int & minimum_height, int & natural_height) const
| Retrieves a cell renderers’s minimum and natural height if it were rendered to widget with the specified width. More...
void | get_preferred_height (Widget & widget, int & minimum_height, int & natural_height) const
| Retrieves a renderer’s natural size when rendered to widget. More...
void | get_preferred_width_for_height (Widget & widget, int height, int & minimum_width, int & natural_width) const
| Retrieves a cell renderers’s minimum and natural width if it were rendered to widget with the specified height. More...
void | get_preferred_size (Widget & widget, Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a cell taking into account the widget’s preference for height-for-width management. More...
Gdk::Rectangle | get_aligned_area (Widget & widget, CellRendererState flags, const Gdk::Rectangle & cell_area) const
| Gets the aligned area used by this CellRenderer inside cell_area. More...
void | snapshot (const Glib::RefPtr< Gtk::Snapshot > & snapshot, Widget & widget, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
| Invokes the virtual render function of the `Gtk::CellRenderer`. More...
bool | activate (const Glib::RefPtr< const Gdk::Event > & event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
| Passes an activate event to the cell renderer for possible processing. More...
CellEditable * | start_editing (const Glib::RefPtr< const Gdk::Event > & event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags=CellRendererState(0))
| Starts editing the contents of this cell, through a new `Gtk::CellEditable` widget created by the `Gtk::CellRenderer`Class.start_editing virtual function. More...
void | set_fixed_size (int width, int height)
| Sets the renderer size to be explicit, independent of the properties set. More...
void | get_fixed_size (int & width, int & height) const
| Fills in width and height with the appropriate size of cell. More...
void | set_alignment (float xalign, float yalign)
| Sets the renderer’s alignment within its available space. More...
void | get_alignment (float & xalign, float & yalign) const
| Fills in xalign and yalign with the appropriate values of cell. More...
void | set_padding (int xpad, int ypad)
| Sets the renderer’s padding. More...
void | get_padding (int & xpad, int & ypad) const
| Fills in xpad and ypad with the appropriate values of cell. More...
void | set_visible (bool visible=true)
| Sets the cell renderer’s visibility. More...
bool | get_visible () const
| Returns the cell renderer’s visibility. More...
void | set_sensitive (bool sensitive=true)
| Sets the cell renderer’s sensitivity. More...
bool | get_sensitive () const
| Returns the cell renderer’s sensitivity. More...
bool | is_activatable () const
| Checks whether the cell renderer can do something when activated. More...
void | set_is_expander (bool is_expander=true)
| Sets whether the given `Gtk::CellRenderer` is an expander. More...
bool | get_is_expander () const
| Checks whether the given `Gtk::CellRenderer` is an expander. More...
void | set_is_expanded (bool is_expanded=true)
| Sets whether the given `Gtk::CellRenderer` is expanded. More...
bool | get_is_expanded () const
| Checks whether the given `Gtk::CellRenderer` is expanded. More...
void | stop_editing (bool canceled=false)
| Informs the cell renderer that the editing is stopped. More...
StateFlags | get_state (Widget & widget, CellRendererState cell_state) const
| Translates the cell renderer state to `Gtk::StateFlags`, based on the cell renderer and widget sensitivity, and the given `Gtk::CellRenderer`State. More...
StateFlags | get_state (CellRendererState cell_state) const
| A get_state() convenience overload. More...
Glib::SignalProxy< void()> | signal_editing_canceled ()
Glib::SignalProxy< void(CellEditable *, const Glib::ustring &)> | signal_editing_started ()
Glib::PropertyProxy< CellRendererMode > | property_mode ()
| Default value: Gtk::CellRendererMode::INERT. More...
Glib::PropertyProxy_ReadOnly< CellRendererMode > | property_mode () const
| Default value: Gtk::CellRendererMode::INERT. More...
Glib::PropertyProxy< bool > | property_visible ()
| Default value: `true` More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Default value: `true` More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Default value: `true` More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Default value: `true` More...
Glib::PropertyProxy< float > | property_xalign ()
| Default value: 0.5. More...
Glib::PropertyProxy_ReadOnly< float > | property_xalign () const
| Default value: 0.5. More...
Glib::PropertyProxy< float > | property_yalign ()
| Default value: 0.5. More...
Glib::PropertyProxy_ReadOnly< float > | property_yalign () const
| Default value: 0.5. More...
Glib::PropertyProxy< unsigned int > | property_xpad ()
| Default value: 0. More...
Glib::PropertyProxy_ReadOnly< unsigned int > | property_xpad () const
| Default value: 0. More...
Glib::PropertyProxy< unsigned int > | property_ypad ()
| Default value: 0. More...
Glib::PropertyProxy_ReadOnly< unsigned int > | property_ypad () const
| Default value: 0. More...
Glib::PropertyProxy< int > | property_width ()
| Default value: -1. More...
Glib::PropertyProxy_ReadOnly< int > | property_width () const
| Default value: -1. More...
Glib::PropertyProxy< int > | property_height ()
| Default value: -1. More...
Glib::PropertyProxy_ReadOnly< int > | property_height () const
| Default value: -1. More...
Glib::PropertyProxy< bool > | property_is_expander ()
| Default value: `false` More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_expander () const
| Default value: `false` More...
Glib::PropertyProxy< bool > | property_is_expanded ()
| Default value: `false` More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_expanded () const
| Default value: `false` More...
Glib::PropertyProxy_WriteOnly< Glib::ustring > | property_cell_background ()
| Default value: "". More...
Glib::PropertyProxy< Gdk::RGBA > | property_cell_background_rgba ()
| Cell background as a `GdkRGBA` More...
Glib::PropertyProxy_ReadOnly< Gdk::RGBA > | property_cell_background_rgba () const
| Cell background as a `GdkRGBA` More...
Glib::PropertyProxy< bool > | property_cell_background_set ()
| Default value: `false` More...
Glib::PropertyProxy_ReadOnly< bool > | property_cell_background_set () const
| Default value: `false` More...
Glib::PropertyProxy_ReadOnly< bool > | property_editing () const
| Default value: `false` More...
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| CellRenderer ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (Widget & widget, int & minimum_width, int & natural_width) const
virtual void | get_preferred_height_for_width_vfunc (Widget & widget, int width, int & minimum_height, int & natural_height) const
virtual void | get_preferred_height_vfunc (Widget & widget, int & minimum_height, int & natural_height) const
virtual void | get_preferred_width_for_height_vfunc (Widget & widget, int height, int & minimum_width, int & natural_width) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > &snapshot, Widget & widget, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
virtual bool | activate_vfunc (const Glib::RefPtr< const Gdk::Event > & event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
virtual CellEditable * | start_editing_vfunc (const Glib::RefPtr< const Gdk::Event > & event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
virtual void | on_editing_canceled ()
| This is a default handler for the signal signal_editing_canceled(). More...
virtual void | on_editing_started (CellEditable * editable, const Glib::ustring & path)
| This is a default handler for the signal signal_editing_started(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Gtk::CellRenderer * | wrap (GtkCellRenderer * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

CellRenderers are used by Gtk::TreeView columns to render the Gtk::TreeModel column data appropriately.

They display, and allow editing of, the values of their properties. In most cases, Gtk::TreeView::append_column() will automatically choose the appropriate renderer for the mode column's data type, so you will rarely need to worry about these classes.

## Constructor & Destructor Documentation

## ◆ CellRenderer() [1/3]

Gtk::CellRenderer::CellRenderer | ( | CellRenderer && | src | ) |
| noexcept

## ◆ CellRenderer() [2/3]

Gtk::CellRenderer::CellRenderer | ( | const CellRenderer & |  | ) |
| delete

## ◆ ~CellRenderer()

Gtk::CellRenderer::~CellRenderer | ( |  | ) |
| overridenoexcept

## ◆ CellRenderer() [3/3]

Gtk::CellRenderer::CellRenderer | ( |  | ) |
| protected

## Member Function Documentation

## ◆ activate()

bool Gtk::CellRenderer::activate | ( | const Glib::RefPtr< const Gdk::Event > & | event,
|  | Widget & | widget,
|  | const Glib::ustring & | path,
|  | const Gdk::Rectangle & | background_area,
|  | const Gdk::Rectangle & | cell_area,
|  | CellRendererState | flags
| ) |  |

Passes an activate event to the cell renderer for possible processing.

Some cell renderers may use events; for example, `Gtk::CellRendererToggle` toggles when it gets a mouse click.

Parameters

  event | A `Gdk::Event`.
  widget | Widget that received the event.
  path | Widget-dependent string representation of the event location; e.g. for `Gtk::TreeView`, a string representation of `Gtk::TreePath`.
  background_area | Background area as passed to gtk_cell_renderer_render().
  cell_area | Cell area as passed to gtk_cell_renderer_render().
  flags | Render flags.

Returns
  `true` if the event was consumed/handled.

## ◆ activate_vfunc()

virtual bool Gtk::CellRenderer::activate_vfunc | ( | const Glib::RefPtr< const Gdk::Event > & | event,
|  | Widget & | widget,
|  | const Glib::ustring & | path,
|  | const Gdk::Rectangle & | background_area,
|  | const Gdk::Rectangle & | cell_area,
|  | CellRendererState | flags
| ) |  |
| protectedvirtual

## ◆ get_aligned_area()

Gdk::Rectangle Gtk::CellRenderer::get_aligned_area | ( | Widget & | widget,
|  | CellRendererState | flags,
|  | const Gdk::Rectangle & | cell_area
| ) |  | const

Gets the aligned area used by this CellRenderer inside cell_area.

Used for finding the appropriate edit and focus rectangle.

Since gtkmm 3.0:

Parameters

  widget | The Gtk::Widget this cell will be rendering to.
  flags | Render flags.
  cell_area | Cell area which would be passed to snapshot().

Returns
  The space inside cell_area that would acually be used to render.

## ◆ get_alignment()

void Gtk::CellRenderer::get_alignment | ( | float & | xalign,
|  | float & | yalign
| ) |  | const

Fills in xalign and yalign with the appropriate values of cell.

Parameters

  xalign | Location to fill in with the x alignment of the cell.
  yalign | Location to fill in with the y alignment of the cell.

## ◆ get_fixed_size()

void Gtk::CellRenderer::get_fixed_size | ( | int & | width,
|  | int & | height
| ) |  | const

Fills in width and height with the appropriate size of cell.

Parameters

  width | Location to fill in with the fixed width of the widget.
  height | Location to fill in with the fixed height of the widget.

## ◆ get_is_expanded()

bool Gtk::CellRenderer::get_is_expanded | ( |  | ) | const

Checks whether the given `Gtk::CellRenderer` is expanded.

Returns
  `true` if the cell renderer is expanded.

## ◆ get_is_expander()

bool Gtk::CellRenderer::get_is_expander | ( |  | ) | const

Checks whether the given `Gtk::CellRenderer` is an expander.

Returns
  `true` if cell is an expander, and `false` otherwise.

## ◆ get_padding()

void Gtk::CellRenderer::get_padding | ( | int & | xpad,
|  | int & | ypad
| ) |  | const

Fills in xpad and ypad with the appropriate values of cell.

Parameters

  xpad | Location to fill in with the x padding of the cell.
  ypad | Location to fill in with the y padding of the cell.

## ◆ get_preferred_height()

void Gtk::CellRenderer::get_preferred_height | ( | Widget & | widget,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const

Retrieves a renderer’s natural size when rendered to widget.

Parameters

  widget | The `Gtk::Widget` this cell will be rendering to.
  minimum_height | Location to store the minimum size.
  natural_height | Location to store the natural size.

## ◆ get_preferred_height_for_width()

void Gtk::CellRenderer::get_preferred_height_for_width | ( | Widget & | widget,
|  | int | width,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const

Retrieves a cell renderers’s minimum and natural height if it were rendered to widget with the specified width.

Parameters

  widget | The `Gtk::Widget` this cell will be rendering to.
  width | The size which is available for allocation.
  minimum_height | Location for storing the minimum size.
  natural_height | Location for storing the preferred size.

## ◆ get_preferred_height_for_width_vfunc()

virtual void Gtk::CellRenderer::get_preferred_height_for_width_vfunc | ( | Widget & | widget,
|  | int | width,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const
| protectedvirtual

## ◆ get_preferred_height_vfunc()

virtual void Gtk::CellRenderer::get_preferred_height_vfunc | ( | Widget & | widget,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const
| protectedvirtual

## ◆ get_preferred_size()

void Gtk::CellRenderer::get_preferred_size | ( | Widget & | widget,
|  | Requisition & | minimum_size,
|  | Requisition & | natural_size
| ) |  | const

Retrieves the minimum and natural size of a cell taking into account the widget’s preference for height-for-width management.

Parameters

  widget | The `Gtk::Widget` this cell will be rendering to.
  minimum_size | Location for storing the minimum size.
  natural_size | Location for storing the natural size.

## ◆ get_preferred_width()

void Gtk::CellRenderer::get_preferred_width | ( | Widget & | widget,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const

Retrieves a renderer’s natural size when rendered to widget.

Parameters

  widget | The `Gtk::Widget` this cell will be rendering to.
  minimum_width | Location to store the minimum size.
  natural_width | Location to store the natural size.

## ◆ get_preferred_width_for_height()

void Gtk::CellRenderer::get_preferred_width_for_height | ( | Widget & | widget,
|  | int | height,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const

Retrieves a cell renderers’s minimum and natural width if it were rendered to widget with the specified height.

Parameters

  widget | The `Gtk::Widget` this cell will be rendering to.
  height | The size which is available for allocation.
  minimum_width | Location for storing the minimum size.
  natural_width | Location for storing the preferred size.

## ◆ get_preferred_width_for_height_vfunc()

virtual void Gtk::CellRenderer::get_preferred_width_for_height_vfunc | ( | Widget & | widget,
|  | int | height,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const
| protectedvirtual

## ◆ get_preferred_width_vfunc()

virtual void Gtk::CellRenderer::get_preferred_width_vfunc | ( | Widget & | widget,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const
| protectedvirtual

## ◆ get_request_mode()

SizeRequestMode Gtk::CellRenderer::get_request_mode | ( |  | ) | const

Gets whether the cell renderer prefers a height-for-width layout or a width-for-height layout.

Returns
  The `Gtk::SizeRequestMode` preferred by this renderer.

## ◆ get_request_mode_vfunc()

virtual SizeRequestMode Gtk::CellRenderer::get_request_mode_vfunc | ( |  | ) | const
| protectedvirtual

## ◆ get_sensitive()

bool Gtk::CellRenderer::get_sensitive | ( |  | ) | const

Returns the cell renderer’s sensitivity.

Returns
  `true` if the cell renderer is sensitive.

## ◆ get_state() [1/2]

StateFlags Gtk::CellRenderer::get_state | ( | CellRendererState | cell_state | ) | const

A get_state() convenience overload.

## ◆ get_state() [2/2]

StateFlags Gtk::CellRenderer::get_state | ( | Widget & | widget,
|  | CellRendererState | cell_state
| ) |  | const

Translates the cell renderer state to `Gtk::StateFlags`, based on the cell renderer and widget sensitivity, and the given `Gtk::CellRenderer`State.

Parameters

  widget | A `Gtk::Widget`.
  cell_state | Cell renderer state.

Returns
  The widget state flags applying to cell.

## ◆ get_type()

static GType Gtk::CellRenderer::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_visible()

bool Gtk::CellRenderer::get_visible | ( |  | ) | const

Returns the cell renderer’s visibility.

Returns
  `true` if the cell renderer is visible.

## ◆ gobj() [1/2]

GtkCellRenderer* Gtk::CellRenderer::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkCellRenderer* Gtk::CellRenderer::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ is_activatable()

bool Gtk::CellRenderer::is_activatable | ( |  | ) | const

Checks whether the cell renderer can do something when activated.

Returns
  `true` if the cell renderer can do anything when activated.

## ◆ on_editing_canceled()

virtual void Gtk::CellRenderer::on_editing_canceled | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_editing_canceled().

## ◆ on_editing_started()

virtual void Gtk::CellRenderer::on_editing_started | ( | CellEditable * | editable,
|  | const Glib::ustring & | path
| ) |  |
| protectedvirtual

This is a default handler for the signal signal_editing_started().

## ◆ operator=() [1/2]

CellRenderer& Gtk::CellRenderer::operator= | ( | CellRenderer && | src | ) |
| noexcept

## ◆ operator=() [2/2]

CellRenderer& Gtk::CellRenderer::operator= | ( | const CellRenderer & |  | ) |
| delete

## ◆ property_cell_background()

Glib::PropertyProxy_WriteOnly< Glib::ustring > Gtk::CellRenderer::property_cell_background | ( |  | ) |

Default value: "".

Returns
  A PropertyProxy_WriteOnly that allows you to set the value of the property, or receive notification when the value of the property changes.

## ◆ property_cell_background_rgba() [1/2]

Glib::PropertyProxy< Gdk::RGBA > Gtk::CellRenderer::property_cell_background_rgba | ( |  | ) |

Cell background as a `GdkRGBA`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_cell_background_rgba() [2/2]

Glib::PropertyProxy_ReadOnly< Gdk::RGBA > Gtk::CellRenderer::property_cell_background_rgba | ( |  | ) | const

Cell background as a `GdkRGBA`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_cell_background_set() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRenderer::property_cell_background_set | ( |  | ) |

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_cell_background_set() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_cell_background_set | ( |  | ) | const

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_editing()

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_editing | ( |  | ) | const

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_height() [1/2]

Glib::PropertyProxy< int > Gtk::CellRenderer::property_height | ( |  | ) |

Default value: -1.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_height() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::CellRenderer::property_height | ( |  | ) | const

Default value: -1.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_is_expanded() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRenderer::property_is_expanded | ( |  | ) |

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_is_expanded() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_is_expanded | ( |  | ) | const

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_is_expander() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRenderer::property_is_expander | ( |  | ) |

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_is_expander() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_is_expander | ( |  | ) | const

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_mode() [1/2]

Glib::PropertyProxy< CellRendererMode > Gtk::CellRenderer::property_mode | ( |  | ) |

Default value: Gtk::CellRendererMode::INERT.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_mode() [2/2]

Glib::PropertyProxy_ReadOnly< CellRendererMode > Gtk::CellRenderer::property_mode | ( |  | ) | const

Default value: Gtk::CellRendererMode::INERT.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_sensitive() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRenderer::property_sensitive | ( |  | ) |

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_sensitive() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_sensitive | ( |  | ) | const

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_visible() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRenderer::property_visible | ( |  | ) |

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_visible() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_visible | ( |  | ) | const

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_width() [1/2]

Glib::PropertyProxy< int > Gtk::CellRenderer::property_width | ( |  | ) |

Default value: -1.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_width() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::CellRenderer::property_width | ( |  | ) | const

Default value: -1.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_xalign() [1/2]

Glib::PropertyProxy< float > Gtk::CellRenderer::property_xalign | ( |  | ) |

Default value: 0.5.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_xalign() [2/2]

Glib::PropertyProxy_ReadOnly< float > Gtk::CellRenderer::property_xalign | ( |  | ) | const

Default value: 0.5.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_xpad() [1/2]

Glib::PropertyProxy< unsigned int > Gtk::CellRenderer::property_xpad | ( |  | ) |

Default value: 0.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_xpad() [2/2]

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::CellRenderer::property_xpad | ( |  | ) | const

Default value: 0.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_yalign() [1/2]

Glib::PropertyProxy< float > Gtk::CellRenderer::property_yalign | ( |  | ) |

Default value: 0.5.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_yalign() [2/2]

Glib::PropertyProxy_ReadOnly< float > Gtk::CellRenderer::property_yalign | ( |  | ) | const

Default value: 0.5.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_ypad() [1/2]

Glib::PropertyProxy< unsigned int > Gtk::CellRenderer::property_ypad | ( |  | ) |

Default value: 0.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_ypad() [2/2]

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::CellRenderer::property_ypad | ( |  | ) | const

Default value: 0.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_alignment()

void Gtk::CellRenderer::set_alignment | ( | float | xalign,
|  | float | yalign
| ) |  |

Sets the renderer’s alignment within its available space.

Parameters

  xalign | The x alignment of the cell renderer.
  yalign | The y alignment of the cell renderer.

## ◆ set_fixed_size()

void Gtk::CellRenderer::set_fixed_size | ( | int | width,
|  | int | height
| ) |  |

Sets the renderer size to be explicit, independent of the properties set.

Parameters

  width | The width of the cell renderer, or -1.
  height | The height of the cell renderer, or -1.

## ◆ set_is_expanded()

void Gtk::CellRenderer::set_is_expanded | ( | bool | is_expanded = `true` | ) |

Sets whether the given `Gtk::CellRenderer` is expanded.

Parameters

  is_expanded | Whether cell should be expanded.

## ◆ set_is_expander()

void Gtk::CellRenderer::set_is_expander | ( | bool | is_expander = `true` | ) |

Sets whether the given `Gtk::CellRenderer` is an expander.

Parameters

  is_expander | Whether cell is an expander.

## ◆ set_padding()

void Gtk::CellRenderer::set_padding | ( | int | xpad,
|  | int | ypad
| ) |  |

Sets the renderer’s padding.

Parameters

  xpad | The x padding of the cell renderer.
  ypad | The y padding of the cell renderer.

## ◆ set_sensitive()

void Gtk::CellRenderer::set_sensitive | ( | bool | sensitive = `true` | ) |

Sets the cell renderer’s sensitivity.

Parameters

  sensitive | The sensitivity of the cell.

## ◆ set_visible()

void Gtk::CellRenderer::set_visible | ( | bool | visible = `true` | ) |

Sets the cell renderer’s visibility.

Parameters

  visible | The visibility of the cell.

## ◆ signal_editing_canceled()

Glib::SignalProxy<void()> Gtk::CellRenderer::signal_editing_canceled | ( |  | ) |

Slot Prototype:
  `void on_my_editing_canceled()`

Flags: Run First

This signal gets emitted when the user cancels the process of editing a cell. For example, an editable cell renderer could be written to cancel editing when the user presses Escape.

See also: Gtk::CellRenderer::stop_editing().

## ◆ signal_editing_started()

Glib::SignalProxy<void(CellEditable*, const Glib::ustring&)> Gtk::CellRenderer::signal_editing_started | ( |  | ) |

Slot Prototype:
  `void on_my_editing_started(CellEditable* editable, const Glib::ustring& path)`

Flags: Run First

This signal gets emitted when a cell starts to be edited. The intended use of this signal is to do special setup on editable, e.g. adding a `Gtk::EntryCompletion` or setting up additional columns in a `Gtk::ComboBox`.

See Gtk::CellEditable::start_editing() for information on the lifecycle of the editable and a way to do setup that doesn’t depend on the renderer.

Note that GTK doesn't guarantee that cell renderers will continue to use the same kind of widget for editing in future releases, therefore you should check the type of editable before doing any specific setup, as in the following example:

[C example ellipted]

Parameters

  editable | The `Gtk::CellEditable`.
  path | The path identifying the edited cell.

## ◆ snapshot()

void Gtk::CellRenderer::snapshot | ( | const Glib::RefPtr< Gtk::Snapshot > & | snapshot,
|  | Widget & | widget,
|  | const Gdk::Rectangle & | background_area,
|  | const Gdk::Rectangle & | cell_area,
|  | CellRendererState | flags
| ) |  |

Invokes the virtual render function of the `Gtk::CellRenderer`.

The three passed-in rectangles are areas in cr. Most renderers will draw within cell_area; the xalign, yalign, xpad, and ypad fields of the `Gtk::CellRenderer` should be honored with respect to cell_area. background_area includes the blank space around the cell, and also the area containing the tree expander; so the background_area rectangles for all cells tile to cover the entire window.

Parameters

  snapshot | A `Gtk::Snapshot` to draw to.
  widget | The widget owning window.
  background_area | Entire cell area (including tree expanders and maybe padding on the sides).
  cell_area | Area normally rendered by a cell renderer.
  flags | Flags that affect rendering.

## ◆ snapshot_vfunc()

virtual void Gtk::CellRenderer::snapshot_vfunc | ( | const Glib::RefPtr< Gtk::Snapshot > & | snapshot,
|  | Widget & | widget,
|  | const Gdk::Rectangle & | background_area,
|  | const Gdk::Rectangle & | cell_area,
|  | CellRendererState | flags
| ) |  |
| protectedvirtual

## ◆ start_editing()

CellEditable* Gtk::CellRenderer::start_editing | ( | const Glib::RefPtr< const Gdk::Event > & | event,
|  | Widget & | widget,
|  | const Glib::ustring & | path,
|  | const Gdk::Rectangle & | background_area,
|  | const Gdk::Rectangle & | cell_area,
|  | CellRendererState | flags = `CellRendererState(0)`
| ) |  |

Starts editing the contents of this cell, through a new `Gtk::CellEditable` widget created by the `Gtk::CellRenderer`Class.start_editing virtual function.

Parameters

  event | A `Gdk::Event`.
  widget | Widget that received the event.
  path | Widget-dependent string representation of the event location; e.g. for `Gtk::TreeView`, a string representation of `Gtk::TreePath`.
  background_area | Background area as passed to gtk_cell_renderer_render().
  cell_area | Cell area as passed to gtk_cell_renderer_render().
  flags | Render flags.

Returns
  A new `Gtk::CellEditable` for editing this cell, or `nullptr` if editing is not possible.

## ◆ start_editing_vfunc()

virtual CellEditable* Gtk::CellRenderer::start_editing_vfunc | ( | const Glib::RefPtr< const Gdk::Event > & | event,
|  | Widget & | widget,
|  | const Glib::ustring & | path,
|  | const Gdk::Rectangle & | background_area,
|  | const Gdk::Rectangle & | cell_area,
|  | CellRendererState | flags
| ) |  |
| protectedvirtual

## ◆ stop_editing()

void Gtk::CellRenderer::stop_editing | ( | bool | canceled = `false` | ) |

Informs the cell renderer that the editing is stopped.

If canceled is `true`, the cell renderer will emit the `Gtk::CellRenderer`::editing-canceled signal.

This function should be called by cell renderer implementations in response to the `GtkCellEditable::editing-done` signal of `Gtk::CellEditable`.

Parameters

  canceled | `true` if the editing has been canceled.

## Friends And Related Function Documentation

## ◆ wrap()

Gtk::CellRenderer * wrap | ( | GtkCellRenderer * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.